diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/bbdisplay/bbgen.h ./bbdisplay/bbgen.h
--- /home/henrik/hobbit/release/hobbit-4.2.0/bbdisplay/bbgen.h	2006-08-09 22:09:54.000000000 +0200
+++ ./bbdisplay/bbgen.h	2006-10-03 13:52:28.000000000 +0200
@@ -51,9 +51,9 @@
                                            dialup               column -------> bbgen_col_t
                                            reportwarnlevel      color             name
                                            comment              age               next
-                                           banks                oldage
-                                           banksize             acked
-                                           next                 alert
+                                           next                 oldage
+                                                                acked
+                                                                alert
                                                                 onwap
                                                                 propagate
                                                                 reportinfo
@@ -140,6 +140,9 @@
 	struct state_t	*next;
 } state_t;
 
+/* OSX has a built-in "host_t" type. */
+#define host_t bbgen_host_t
+
 typedef struct host_t {
 	char	*hostname;
 	char	*displayname;
@@ -166,8 +169,6 @@
 	struct bbgen_page_t *parent;
 	double  reportwarnlevel;
 	char	*reporttime;
-	int     *banks;
-	int     banksize;
 	int     nobb2;
 	struct host_t	*next;
 } host_t;
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/bbdisplay/loadbbhosts.c ./bbdisplay/loadbbhosts.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/bbdisplay/loadbbhosts.c	2006-08-09 22:09:54.000000000 +0200
+++ ./bbdisplay/loadbbhosts.c	2007-02-09 11:01:19.389403275 +0100
@@ -109,7 +109,7 @@
 	}
 
 	xfree(set);
-	return ((strlen(result) > 0) ? result : NULL);
+	return result;	/* This may be an empty string */
 }
 
 bbgen_page_t *init_page(char *name, char *title)
@@ -174,8 +174,7 @@
 		  int ip1, int ip2, int ip3, int ip4, 
 		  int dialup, double warnpct, char *reporttime,
 		  char *alerts, int nktime, char *waps,
-		  char *nopropyellowtests, char *nopropredtests, char *noproppurpletests, char *nopropacktests,
-		  int modembanksize)
+		  char *nopropyellowtests, char *nopropredtests, char *noproppurpletests, char *nopropacktests)
 {
 	host_t 		*newhost = (host_t *) calloc(1, sizeof(host_t));
 	hostlist_t	*oldlist;
@@ -256,21 +255,6 @@
 	}
 
 	newhost->parent = NULL;
-	newhost->banks = NULL;
-	newhost->banksize = modembanksize;
-	if (modembanksize) {
-		int i;
-		newhost->banks = (int *) calloc(modembanksize, sizeof(int));
-		for (i=0; i<modembanksize; i++) newhost->banks[i] = -1;
-
-		if (comment) {
-			newhost->comment = (char *) realloc(newhost->comment, strlen(newhost->comment) + 22);
-			sprintf(newhost->comment+strlen(newhost->comment), " - [%s]", newhost->ip);
-		}
-		else {
-			newhost->comment = newhost->ip;
-		}
-	}
 	newhost->nobb2 = 0;
 	newhost->next = NULL;
 
@@ -440,7 +424,6 @@
 	host_t	*curhost;
 	char	*curtitle;
 	int	ip1, ip2, ip3, ip4;
-	int	modembanksize;
 	char	*p;
 	int	fqdn = get_fqdn();
 
@@ -482,8 +465,6 @@
 
 		dbgprintf("load_bbhosts: -- got line '%s'\n", STRBUF(inbuf));
 
-		modembanksize = 0;
-
 		if (strncmp(STRBUF(inbuf), pagetag, strlen(pagetag)) == 0) {
 			getnamelink(STRBUF(inbuf), &name, &link);
 			if (curpage == NULL) {
@@ -581,9 +562,7 @@
 			if (curtitle) { curgroup->pretitle = curtitle; curtitle = NULL; }
 			curhost = NULL;
 		}
-		else if ( (sscanf(STRBUF(inbuf), "%3d.%3d.%3d.%3d %s", &ip1, &ip2, &ip3, &ip4, hostname) == 5) ||
-		          (!reportstart && !snapshot && (sscanf(STRBUF(inbuf), "dialup %s %d.%d.%d.%d %d", hostname, &ip1, &ip2, &ip3, &ip4, &modembanksize) == 6) && (modembanksize > 0)) ) {
-
+		else if (sscanf(STRBUF(inbuf), "%3d.%3d.%3d.%3d %s", &ip1, &ip2, &ip3, &ip4, hostname) == 5) {
 			namelist_t *bbhost = NULL;
 			int dialup, nobb2, nktime = 1;
 			double warnpct = reportwarnlevel;
@@ -685,8 +664,7 @@
 							    ip1, ip2, ip3, ip4, dialup, 
 							    warnpct, reporttime,
 							    alertlist, nktime, onwaplist,
-							    nopropyellowlist, nopropredlist, noproppurplelist, nopropacklist,
-							    modembanksize);
+							    nopropyellowlist, nopropredlist, noproppurplelist, nopropacklist);
 					if (curgroup != NULL) {
 						curgroup->hosts = curhost;
 					}
@@ -710,8 +688,7 @@
 									    warnpct, reporttime,
 									    alertlist, nktime, onwaplist,
 									    nopropyellowlist,nopropredlist, 
-									    noproppurplelist, nopropacklist,
-									    modembanksize);
+									    noproppurplelist, nopropacklist);
 				}
 				curhost->parent = (cursubparent ? cursubparent : (cursubpage ? cursubpage : curpage));
 				if (curtitle) { curhost->pretitle = curtitle; curtitle = NULL; }
@@ -758,8 +735,7 @@
 									    warnpct, reporttime,
 									    alertlist, nktime, onwaplist,
 									    nopropyellowlist,nopropredlist, 
-									    noproppurplelist, nopropacklist,
-									    modembanksize);
+									    noproppurplelist, nopropacklist);
 
 						if (wantedgroup > 0) {
 							group_t *gwalk;
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/bbdisplay/loadbbhosts.h ./bbdisplay/loadbbhosts.h
--- /home/henrik/hobbit/release/hobbit-4.2.0/bbdisplay/loadbbhosts.h	2006-08-09 22:09:54.000000000 +0200
+++ ./bbdisplay/loadbbhosts.h	2006-10-03 13:52:28.000000000 +0200
@@ -24,8 +24,7 @@
 			 int dialup,
 			 double warnpct, char *reporttime,
 			 char *alerts, int nktime, char *waps,
-			 char *nopropyellowtests, char *nopropredtests, char *noproppurpletests, char *nopropacktests,
-			 int modembanksize);
+			 char *nopropyellowtests, char *nopropredtests, char *noproppurpletests, char *nopropacktests);
 
 extern char	*nopropyellowdefault;
 extern char	*nopropreddefault;
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/bbdisplay/loaddata.c ./bbdisplay/loaddata.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/bbdisplay/loaddata.c	2006-08-09 22:09:54.000000000 +0200
+++ ./bbdisplay/loaddata.c	2006-10-03 13:52:28.000000000 +0200
@@ -182,12 +182,6 @@
 
 	host = find_host(hostname);
 
-	/* If the host is a modem-bank host, dont mix in normal status messages */
-	if (host && (host->banksize > 0)) {
-		errprintf("Modembank %s has additional status-logs - ignored\n", hostname);
-		return NULL;
-	}
-
 	newstate = (state_t *) calloc(1, sizeof(state_t));
 	newstate->entry = (entry_t *) calloc(1, sizeof(entry_t));
 	newstate->next = NULL;
@@ -347,72 +341,6 @@
 	return newsum;
 }
 
-void init_modembank_status(char *fn, logdata_t *log)
-{
-	char *msgcopy;
-	host_t *targethost;
-	time_t now = time(NULL);
-
-	dbgprintf("init_modembank_status(%s)\n", textornull(fn));
-
-	if (log->validtime < now) return;
-
-	targethost = find_host(fn+strlen("dialup."));
-	if (targethost == NULL) {
-		dbgprintf("Modembank status from unknown host %s - ignored\n", fn+strlen("dialup."));
-		return;
-	}
-
-	msgcopy = strdup(log->msg);
-	if (strlen(msgcopy)) {
-		char *startip, *endip, *tag;
-		int idx = -1;
-
-		startip = endip = NULL;
-		tag = strtok(msgcopy, " \n");
-		while (tag) {
-			if (idx >= 0) {
-				/* Next result */
-				if (idx < targethost->banksize) targethost->banks[idx] = parse_color(tag);
-				idx++;
-			}
-			else if (strcmp(tag, "DATA") == 0) {
-				if (startip && endip) idx = 0;
-				else errprintf("Invalid modembank status logfile %s (missing FROM and/or TO)\n", fn);
-			}
-			else if (strcmp(tag, "FROM") == 0) {
-				tag = strtok(NULL, " \n");
-
-				if (tag) {
-					startip = tag;
-					if (strcmp(startip, targethost->ip) != 0) {
-						errprintf("Modembank in bb-hosts begins with %s, but logfile begins with %s\n",
-						  	targethost->ip, startip);
-					}
-				} else errprintf("Invalid modembank status logfile %s (truncated)\n", fn);
-			}
-			else if (strcmp(tag, "TO") == 0) {
-				tag = strtok(NULL, " \n");
-
-				if (tag) {
-					if (startip) endip = tag;
-					else errprintf("Invalid modembank status logfile %s (no FROM)\n", fn);
-				} else errprintf("Invalid modembank status logfile %s (truncated)\n", fn);
-			}
-
-			if (tag) tag = strtok(NULL, " \n");
-		}
-
-		if ((idx >= 0) && (idx != targethost->banksize)) {
-			errprintf("Modembank status log %s has more entries (%d) than expected (%d)\n", 
-				  fn, (idx-1), targethost->banksize);
-		}
-	}
-
-	xfree(msgcopy);
-}
-
-
 state_t *load_state(dispsummary_t **sumhead)
 {
 	int hobbitdresult;
@@ -506,9 +434,6 @@
 				}
 			}
 		}
-		else if (strncmp(fn, "dialup.", 7) == 0) {
-			init_modembank_status(fn, &log);
-		}
 		else {
 			if (acklist && *acklist) {
 				/*
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/bbdisplay/pagegen.c ./bbdisplay/pagegen.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/bbdisplay/pagegen.c	2006-08-09 22:09:54.000000000 +0200
+++ ./bbdisplay/pagegen.c	2006-10-03 13:52:28.000000000 +0200
@@ -322,8 +322,6 @@
 	int	genstatic;
 	int	columncount;
 	char	*bbskin;
-	int	maxbanksize = 0;
-	int	anyplainhosts = 0;
 	int	rowcount = 0;
 
 	if (head == NULL)
@@ -338,27 +336,10 @@
 	else fprintf(output, "<A NAME=hosts-blk-%d>&nbsp;</A>\n\n", hostblkidx);
 	hostblkidx++;
 
-	for (h = head; (h); h = h->next) {
-		if (h->banksize > maxbanksize) maxbanksize = h->banksize;
-		if (h->banksize == 0) anyplainhosts = 1;
-	}
-
-	if (maxbanksize == 0) {
-		/* No modembanks - normal hostlist with columns and stuff */
-		groupcols = gen_column_list(head, pagetype, onlycols, exceptcols);
-		for (columncount=0, gc=groupcols; (gc); gc = gc->next, columncount++) ;
-	}
-	else {
-		/* There are modembanks here! */
-		if (anyplainhosts) {
-			errprintf("WARNING: Modembank displays should be in their own group or page.\nMixing normal hosts with modembanks yield strange output.\n");
-		}
-		groupcols = NULL;
-		columncount = maxbanksize;
-	}
-
-	if (groupcols || (maxbanksize > 0)) {
+	groupcols = gen_column_list(head, pagetype, onlycols, exceptcols);
+	for (columncount=0, gc=groupcols; (gc); gc = gc->next, columncount++) ;
 
+	if (groupcols) {
 		int width;
 
 		width = atoi(xgetenv("DOTWIDTH"));
@@ -386,29 +367,11 @@
 				fprintf(output, "<TD VALIGN=MIDDLE ROWSPAN=2><CENTER><FONT %s>%s</FONT></CENTER></TD>\n", 
 					xgetenv("MKBBTITLE"), (strlen(grouptitle) ? grouptitle : "&nbsp;"));
 
-				if ((groupcols == NULL) && (maxbanksize > 0)) {
-					int i,j;
-
-					fprintf(output, "<TD><TABLE BORDER=0>\n");
-					for (i=0; (i < maxbanksize); i+=16) {
-						fprintf(output, "<TR>\n");
-						for (j=i; (((j-i) < 16) && (j < maxbanksize)); j++) {
-							fprintf(output, " <TD ALIGN=CENTER VALIGN=BOTTOM WIDTH=%d>", width);
-							fprintf(output, " <FONT %s><B>%d</B></FONT>", 
-								xgetenv("MKBBCOLFONT"), j);
-							fprintf(output, " </TD>\n");
-						}
-						fprintf(output, "</TR>\n");
-					}
-					fprintf(output, "</TABLE></TD>\n");
-				}
-				else {
-					for (gc=groupcols; (gc); gc = gc->next) {
-						fprintf(output, " <TD ALIGN=CENTER VALIGN=BOTTOM WIDTH=45>\n");
-						fprintf(output, " <A HREF=\"%s\"><FONT %s><B>%s</B></FONT></A> </TD>\n", 
-							columnlink(gc->column->name), 
-							xgetenv("MKBBCOLFONT"), gc->column->name);
-					}
+				for (gc=groupcols; (gc); gc = gc->next) {
+					fprintf(output, " <TD ALIGN=CENTER VALIGN=BOTTOM WIDTH=45>\n");
+					fprintf(output, " <A HREF=\"%s\"><FONT %s><B>%s</B></FONT></A> </TD>\n", 
+						columnlink(gc->column->name), 
+						xgetenv("MKBBCOLFONT"), gc->column->name);
 				}
 				fprintf(output, "</TR> \n<TR><TD COLSPAN=%d><HR WIDTH=\"100%%\"></TD></TR>\n\n", columncount);
 			}
@@ -421,44 +384,6 @@
 				hostnamehtml(h->hostname, ((pagetype != PAGE_BB) ? hostpage_link(h) : NULL)) );
 
 			/* Then the columns. */
-			if ((groupcols == NULL) && (h->banksize > 0)) {
-				int i, j;
-				char alttag[30];
-				unsigned int baseip, ip1, ip2, ip3, ip4;
-
-				sscanf(h->ip, "%u.%u.%u.%u", &ip1, &ip2, &ip3, &ip4);
-				baseip = IPtou32(ip1, ip2, ip3, ip4);
-
-				fprintf(output, "<TD ALIGN=CENTER><TABLE BORDER=0>");
-				for (i=0; (i < h->banksize); i+=16) {
-					fprintf(output, "<TR>\n");
-					for (j=i; (((j-i) < 16) && (j < h->banksize)); j++) {
-						fprintf(output, "<TD ALIGN=CENTER VALIGN=BOTTOM WIDTH=%d>", width);
-
-						if (genstatic) {
-							/*
-							 * Dont use htmlextension here - it's for the
-							 * pages generated by bbd.
-							 */
-							fprintf(output, "<A HREF=\"%s/html/dialup.%s.html\">",
-								xgetenv("BBWEB"), h->hostname);
-						}
-						else {
-							fprintf(output, "<A HREF=\"%s\">", 
-								hostsvcurl("dialup", commafy(h->hostname), 1));
-						}
-	
-						sprintf(alttag, "%s:%s", u32toIP(baseip+j), colorname(h->banks[j]));
-						fprintf(output, "<IMG SRC=\"%s/%s\" ALT=\"%s\" TITLE=\"%s\" HEIGHT=\"%s\" WIDTH=\"%s\" BORDER=0></A>",
-							bbskin, dotgiffilename(h->banks[j], 0, 0),
-							alttag, alttag, xgetenv("DOTHEIGHT"), xgetenv("DOTWIDTH"));
-
-						fprintf(output, "</TD>\n");
-					}
-					fprintf(output, "</TR>\n");
-				}
-				fprintf(output, "</TABLE></TD>\n");
-			}
 			for (gc = groupcols; (gc); gc = gc->next) {
 				char *htmlalttag;
 
@@ -657,7 +582,7 @@
 
 		if (newhost == NULL) {
 			/* New summary "host" */
-			newhost = init_host(s->row, 1, NULL, NULL, NULL, NULL, 0,0,0,0, 0, 0.0, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, 0);
+			newhost = init_host(s->row, 1, NULL, NULL, NULL, NULL, 0,0,0,0, 0, 0.0, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
 
 			/* Insert into sorted host list */
 			if ((!sumhosts) || (strcmp(newhost->hostname, sumhosts->hostname) < 0)) {
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/bbnet/bbtest-net.c ./bbnet/bbtest-net.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/bbnet/bbtest-net.c	2006-08-09 22:09:55.000000000 +0200
+++ ./bbnet/bbtest-net.c	2006-10-03 13:52:28.000000000 +0200
@@ -64,27 +64,13 @@
 	NULL
 };
 
-/* toolid values */
-#define TOOL_CONTEST	0
-#define TOOL_NSLOOKUP	1
-#define TOOL_DIG	2
-#define TOOL_NTP        3
-#define TOOL_FPING      4
-#define TOOL_HTTP       5
-#define TOOL_MODEMBANK  6
-#define TOOL_LDAP	7
-#define TOOL_RPCINFO	8
-
-
 RbtHandle	svctree;			/* All known services, has service_t records */
 service_t	*pingtest = NULL;		/* Identifies the pingtest within svctree list */
 int		pingcount = 0;
 service_t	*dnstest = NULL;		/* Identifies the dnstest within svctree list */
-service_t	*digtest = NULL;		/* Identifies the digtest within svctree list */
 service_t	*httptest = NULL;		/* Identifies the httptest within svctree list */
 service_t	*ldaptest = NULL;		/* Identifies the ldaptest within svctree list */
 service_t	*rpctest = NULL;		/* Identifies the rpctest within svctree list */
-service_t	*modembanktest = NULL;		/* Identifies the modembank test within svctree list */
 RbtHandle       testhosttree;			/* All tested hosts, has testedhost_t records */
 char		*nonetpage = NULL;		/* The "NONETPAGE" env. variable */
 int		dnsmethod = DNS_THEN_IP;	/* How to do DNS lookups */
@@ -157,35 +143,21 @@
 		printf("Service %s, port %d, toolid %d\n", swalk->testname, swalk->portnum, swalk->toolid);
 
 		for (iwalk = swalk->items; (iwalk); iwalk = iwalk->next) {
-			if (swalk == modembanktest) {
-				modembank_t *mentry;
-				int i;
-
-				mentry = iwalk->privdata;
-				printf("\tModembank   : %s\n", textornull(mentry->hostname));
-				printf("\tStart-IP    : %s\n", u32toIP(mentry->startip));
-				printf("\tBanksize    : %d\n", mentry->banksize);
-				printf("\tOpen        :");
-				for (i=0; i<mentry->banksize; i++) printf(" %d", mentry->responses[i]);
-				printf("\n");
-			}
-			else {
-				printf("\tHost        : %s\n", textornull(iwalk->host->hostname));
-				printf("\ttestspec    : %s\n", textornull(iwalk->testspec));
-				printf("\tFlags       :");
-				if (iwalk->dialup) printf(" dialup");
-				if (iwalk->reverse) printf(" reverse");
-				if (iwalk->silenttest) printf(" silenttest");
-				if (iwalk->alwaystrue) printf(" alwaystrue");
-				printf("\n");
-				printf("\tOpen        : %d\n", iwalk->open);
-				printf("\tBanner      : %s\n", textornull(STRBUF(iwalk->banner)));
-				printf("\tcertinfo    : %s\n", textornull(iwalk->certinfo));
-				printf("\tDuration    : %ld.%06ld\n", (long int)iwalk->duration.tv_sec, (long int)iwalk->duration.tv_usec);
-				printf("\tbadtest     : %d:%d:%d\n", iwalk->badtest[0], iwalk->badtest[1], iwalk->badtest[2]);
-				printf("\tdowncount    : %d started %s", iwalk->downcount, ctime(&iwalk->downstart));
-				printf("\n");
-			}
+			printf("\tHost        : %s\n", textornull(iwalk->host->hostname));
+			printf("\ttestspec    : %s\n", textornull(iwalk->testspec));
+			printf("\tFlags       :");
+			if (iwalk->dialup) printf(" dialup");
+			if (iwalk->reverse) printf(" reverse");
+			if (iwalk->silenttest) printf(" silenttest");
+			if (iwalk->alwaystrue) printf(" alwaystrue");
+			printf("\n");
+			printf("\tOpen        : %d\n", iwalk->open);
+			printf("\tBanner      : %s\n", textornull(STRBUF(iwalk->banner)));
+			printf("\tcertinfo    : %s\n", textornull(iwalk->certinfo));
+			printf("\tDuration    : %ld.%06ld\n", (long int)iwalk->duration.tv_sec, (long int)iwalk->duration.tv_usec);
+			printf("\tbadtest     : %d:%d:%d\n", iwalk->badtest[0], iwalk->badtest[1], iwalk->badtest[2]);
+			printf("\tdowncount    : %d started %s", iwalk->downcount, ctime(&iwalk->downstart));
+			printf("\n");
 		}
 
 		printf("\n");
@@ -423,35 +395,6 @@
 
 		if (!wanted_host(hwalk, location)) continue;
 
-		if (argnmatch(hwalk->bbhostname, "@dialup.")) {
-			/* Modembank entry: "dialup displayname startIP count" */
-
-			char *realname;
-			testitem_t *newtest;
-			modembank_t *newentry;
-			int i, ip1, ip2, ip3, ip4, banksize;
-
-			realname = hwalk->bbhostname + strlen("@dialup.");
-			banksize = atoi(bbh_item(hwalk, BBH_BANKSIZE));
-			sscanf(bbh_item(hwalk, BBH_IP), "%d.%d.%d.%d", &ip1, &ip2, &ip3, &ip4);
-
-			newtest = init_testitem(NULL, modembanktest, NULL, 0, 0, 0, 0, 0);
-			newtest->next = modembanktest->items;
-			modembanktest->items = newtest;
-
-			newtest->privdata = (void *)malloc(sizeof(modembank_t));
-			newentry = (modembank_t *)newtest->privdata;
-			newentry->hostname = realname;
-			newentry->startip = IPtou32(ip1, ip2, ip3, ip4);
-			newentry->banksize = banksize;
-			newentry->responses = (int *) malloc(banksize * sizeof(int));
-			for (i=0; i<banksize; i++) newentry->responses[i] = 0;
-
-			/* No more to do for modembanks */
-			continue;
-		}
-
-
 		h = init_testedhost(hwalk->bbhostname);
 
 		p = bbh_custom_item(hwalk, "badconn:");
@@ -645,7 +588,7 @@
 					s = dnstest;
 				}
 				else if (argnmatch(testspec, "dig=")) {
-					s = digtest;
+					s = dnstest;
 				}
 				else {
 					/* 
@@ -1311,60 +1254,6 @@
 	return 0;
 }
 
-void run_modembank_service(service_t *service)
-{
-	testitem_t	*t;
-	char		cmd[1024];
-	char		startip[IP_ADDR_STRLEN], endip[IP_ADDR_STRLEN];
-	char		*p;
-	char		cmdpath[PATH_MAX];
-	FILE		*cmdpipe;
-	char		l[MAX_LINE_LEN];
-	int		ip1, ip2, ip3, ip4;
-
-	for (t=service->items; (t); t = t->next) {
-		modembank_t *req = (modembank_t *)t->privdata;
-
-		p = xgetenv("FPING");
-		strcpy(cmdpath, (p ? p : "hobbitping"));
-		strcpy(startip, u32toIP(req->startip));
-		strcpy(endip, u32toIP(req->startip + req->banksize - 1));
-		sprintf(cmd, "%s -g -Ae %s %s 2>/dev/null", cmdpath, startip, endip);
-
-		dbgprintf("Running command: '%s'\n", cmd);
-		cmdpipe = popen(cmd, "r");
-		if (cmdpipe == NULL) {
-			errprintf("Could not run the hobbitping command %s\n", cmd);
-			return;
-		}
-
-		while (fgets(l, sizeof(l), cmdpipe)) {
-			dbgprintf("modembank response: %s", l);
-
-			if (sscanf(l, "%d.%d.%d.%d ", &ip1, &ip2, &ip3, &ip4) == 4) {
-				unsigned int idx = IPtou32(ip1, ip2, ip3, ip4) - req->startip;
-
-				if (idx >= req->banksize) {
-					errprintf("Unexpected response for IP not in bank - %d.%d.%d.%d", 
-						  ip1, ip2, ip3, ip4);
-				}
-				else {
-					req->responses[idx] = (strstr(l, "is alive") != NULL);
-				}
-			}
-		}
-		pclose(cmdpipe);
-
-		if (debug) {
-			int i;
-
-			dbgprintf("Results for modembank start=%s, length %d\n", u32toIP(req->startip), req->banksize);
-			for (i=0; (i<req->banksize); i++)
-				dbgprintf("\t%s is %d\n", u32toIP(req->startip+i), req->responses[i]);
-		}
-	}
-}
-
 
 int decide_color(service_t *service, char *svcname, testitem_t *test, int failgoesclear, char *cause)
 {
@@ -1756,44 +1645,6 @@
 }
 
 
-void send_modembank_results(service_t *service)
-{
-	testitem_t	*t;
-	char		msgline[1024];
-	int		i, color, inuse;
-	char		startip[IP_ADDR_STRLEN], endip[IP_ADDR_STRLEN];
-
-	for (t=service->items; (t); t = t->next) {
-		modembank_t *req = (modembank_t *)t->privdata;
-
-		inuse = 0;
-		strcpy(startip, u32toIP(req->startip));
-		strcpy(endip, u32toIP(req->startip + req->banksize - 1));
-
-		init_status(COL_GREEN);		/* Modembanks are always green */
-		sprintf(msgline, "status dialup.%s %s %s FROM %s TO %s DATA ", 
-			req->hostname, colorname(COL_GREEN), timestamp, startip, endip);
-		addtostatus(msgline);
-		for (i=0; i<req->banksize; i++) {
-			if (req->responses[i]) {
-				color = COL_GREEN;
-				inuse++;
-			}
-			else {
-				color = COL_CLEAR;
-			}
-
-			sprintf(msgline, "%s ", colorname(color));
-			addtostatus(msgline);
-		}
-
-		sprintf(msgline, "\n\nUsage: %d of %d (%d%%)\n", inuse, req->banksize, ((inuse * 100) / req->banksize));
-		addtostatus(msgline);
-		finish_status();
-	}
-}
-
-
 void send_rpcinfo_results(service_t *service, int failgoesclear)
 {
 	testitem_t	*t;
@@ -2234,14 +2085,12 @@
 		return 0;
 	}
 
-	dnstest = add_service("dns", getportnumber("domain"), 0, TOOL_NSLOOKUP);
-	digtest = add_service("dig", getportnumber("domain"), 0, TOOL_DIG);
+	dnstest = add_service("dns", getportnumber("domain"), 0, TOOL_DNS);
 	add_service("ntp", getportnumber("ntp"),    0, TOOL_NTP);
 	rpctest  = add_service("rpc", getportnumber("sunrpc"), 0, TOOL_RPCINFO);
 	httptest = add_service("http", getportnumber("http"),  0, TOOL_HTTP);
 	ldaptest = add_service("ldapurl", getportnumber("ldap"), strlen("ldap"), TOOL_LDAP);
 	if (pingcolumn) pingtest = add_service(pingcolumn, 0, 0, TOOL_FPING);
-	modembanktest = add_service("dialup", 0, 0, TOOL_MODEMBANK);
 	add_timestamp("Service definitions loaded");
 
 	load_tests();
@@ -2360,18 +2209,14 @@
 	add_timestamp("LDAP tests result collection completed");
 
 
-	/* dns, dig, ntp tests */
+	/* dns, ntp tests */
 	for (handle = rbtBegin(svctree); handle != rbtEnd(svctree); handle = rbtNext(svctree, handle)) {
 		s = (service_t *)gettreeitem(svctree, handle);
 		if (s->items) {
 			switch(s->toolid) {
-				case TOOL_NSLOOKUP:
+				case TOOL_DNS:
 					run_nslookup_service(s); 
-					add_timestamp("NSLOOKUP tests executed");
-					break;
-				case TOOL_DIG:
-					run_nslookup_service(s); 
-					add_timestamp("DIG tests executed");
+					add_timestamp("DNS tests executed");
 					break;
 				case TOOL_NTP:
 					run_ntp_service(s); 
@@ -2381,9 +2226,7 @@
 					run_rpcinfo_service(s); 
 					add_timestamp("RPC tests executed");
 					break;
-				case TOOL_MODEMBANK:
-					run_modembank_service(s); 
-					add_timestamp("Modembank tests executed");
+				default:
 					break;
 			}
 		}
@@ -2394,8 +2237,7 @@
 		s = (service_t *)gettreeitem(svctree, handle);
 		switch (s->toolid) {
 			case TOOL_CONTEST:
-			case TOOL_NSLOOKUP:
-			case TOOL_DIG:
+			case TOOL_DNS:
 			case TOOL_NTP:
 				send_results(s, failgoesclear);
 				break;
@@ -2406,10 +2248,6 @@
 				/* These handle result-transmission internally */
 				break;
 
-			case TOOL_MODEMBANK:
-				send_modembank_results(s);
-				break;
-
 			case TOOL_RPCINFO:
 				send_rpcinfo_results(s, failgoesclear);
 				break;
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/bbnet/bbtest-net.h ./bbnet/bbtest-net.h
--- /home/henrik/hobbit/release/hobbit-4.2.0/bbnet/bbtest-net.h	2006-08-09 22:09:55.000000000 +0200
+++ ./bbnet/bbtest-net.h	2006-10-03 13:52:28.000000000 +0200
@@ -19,6 +19,9 @@
 
 #define MAX_CONTENT_DATA (1024*1024)	/* 1 MB should be enough for most */
 
+/* toolids */
+enum toolid_t { TOOL_CONTEST, TOOL_DNS, TOOL_NTP, TOOL_FPING, TOOL_HTTP, TOOL_LDAP, TOOL_RPCINFO };
+
 /*
  * Structure of the bbtest-net in-memory records
  *
@@ -62,12 +65,11 @@
 	char *testname;		/* Name of the test = column name in Hobbit report */
 	int namelen;		/* Length of name - "testname:port" has this as strlen(testname), others 0 */
 	int portnum;		/* Port number this service runs on */
-	int toolid;		/* Which tool to use */
+	enum toolid_t toolid;	/* Which tool to use */
 	struct testitem_t *items; /* testitem_t linked list of tests for this service */
 } service_t;
 
-#define MULTIPING_BEST 0
-#define MULTIPING_WORST 1
+enum multiping_t { MULTIPING_BEST, MULTIPING_WORST };
 typedef struct ipping_t {
 	char *ip;
 	int  open;
@@ -76,7 +78,7 @@
 } ipping_t;
 
 typedef struct extraping_t {
-	int   matchtype;
+	enum multiping_t matchtype;
 	ipping_t *iplist;
 } extraping_t;
 
@@ -150,13 +152,6 @@
 	struct testitem_t *next;
 } testitem_t;
 
-typedef struct modembank_t {
-	char		*hostname;
-	unsigned int 	startip;	/* Saved as 32-bit binary */
-	int		banksize;
-	int		*responses;
-} modembank_t;
-
 typedef struct dnstest_t {
 	int	testcount;
 	int	okcount;
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/build/bb-commands.sh ./build/bb-commands.sh
--- /home/henrik/hobbit/release/hobbit-4.2.0/build/bb-commands.sh	2006-08-09 22:09:57.000000000 +0200
+++ ./build/bb-commands.sh	2006-10-03 12:55:27.000000000 +0200
@@ -23,23 +23,13 @@
 echo "# Hobbit does not use them, but they are provided here so if you use BB extension"
 echo "# scripts, then they will hopefully run without having to do a lot of tweaking."
 echo ""
-for CMD in uptime awk cat cp cut date egrep expr find grep head id ln ls mv rm sed sort tail touch tr uniq who
+for CMD in uptime awk cat cp cut date egrep expr find grep head id ln ls mv rm sed sort tail top touch tr uniq who
 do
 	ENVNAME=`echo $CMD | tr "[a-z]" "[A-Z]"`
 	PGM=`findbin $CMD | head -n 1`
 	echo "${ENVNAME}=\"${PGM}\""
 done
 
-# TOP can either be "top", or on Solaris the "prstat" command.
-PRSTAT=`findbin prstat | head -n 1`
-if test "$PRSTAT" != ""
-then
-	PGM="$PRSTAT -can 20 1 1"
-else
-	PGM=`findbin top | head -n 1`
-fi
-echo "TOP=\"${PGM}\""
-
 # WC is special
 PGM=`findbin wc | head -n 1`
 echo "WC=\"${PGM} -l\""
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/client/hobbitclient-aix.sh ./client/hobbitclient-aix.sh
--- /home/henrik/hobbit/release/hobbit-4.2.0/client/hobbitclient-aix.sh	2006-08-09 22:09:58.000000000 +0200
+++ ./client/hobbitclient-aix.sh	2006-10-03 13:52:28.000000000 +0200
@@ -36,7 +36,7 @@
 echo "[ifconfig]"
 ifconfig -a
 echo "[route]"
-netstat -r
+netstat -rn
 echo "[netstat]"
 netstat -s
 echo "[ports]"
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/client/hobbitclient-darwin.sh ./client/hobbitclient-darwin.sh
--- /home/henrik/hobbit/release/hobbit-4.2.0/client/hobbitclient-darwin.sh	2006-08-09 22:09:58.000000000 +0200
+++ ./client/hobbitclient-darwin.sh	2006-10-03 13:52:28.000000000 +0200
@@ -33,7 +33,7 @@
 echo "[ifconfig]"
 ifconfig -a
 echo "[route]"
-netstat -r
+netstat -rn
 echo "[netstat]"
 netstat -s
 echo "[ifstat]"
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/client/hobbitclient-sunos.sh ./client/hobbitclient-sunos.sh
--- /home/henrik/hobbit/release/hobbit-4.2.0/client/hobbitclient-sunos.sh	2006-08-09 22:09:58.000000000 +0200
+++ ./client/hobbitclient-sunos.sh	2006-10-03 12:55:27.000000000 +0200
@@ -22,7 +22,7 @@
 
 echo "[df]"
 # All of this because Solaris df cannot show multiple fs-types, or exclude certain fs types.
-FSTYPES=`/bin/df -n -l|awk '{print $3}'|egrep -v "^proc|^fd|^mntfs|^ctfs|^devfs|^objfs|^nfs"|sort|uniq`
+FSTYPES=`/bin/df -n -l|awk '{print $3}'|egrep -v "^proc|^fd|^mntfs|^ctfs|^devfs|^objfs|^nfs|^lofs"|sort|uniq`
 if test "$FSTYPES" = ""; then FSTYPES="ufs"; fi
 set $FSTYPES
 /bin/df -F $1 -k | grep -v " /var/run"
@@ -54,14 +54,13 @@
 echo "[ps]"
 ps -A -o pid,ppid,user,stime,s,pri,pcpu,time,pmem,rss,vsz,args
 
-# $TOP must be set, the install utility should do that for us if it exists.
-if test "$TOP" != ""
+# If TOP is defined, then use it. If not, fall back to the Solaris prstat command.
+echo "[top]"
+if test "$TOP" != "" -a -x "$TOP"
 then
-    if test -x "$TOP"
-    then
-        echo "[top]"
-        $TOP -b 20
-    fi
+	"$TOP" -b 20
+else
+	prstat -can 20 1 1
 fi
 
 # vmstat and iostat (iostat -d provides a cpu utilisation with I/O wait number)
